import java.awt.Dimension;
import java.awt.Graphics;

import javax.swing.JComponent;

/**
 * @author F. Mallet
 * Modle MVC : Le controleur dlgue le comptage  son modle et 
 * l'affichage  sa vue
 */
public class CompteurControle extends JComponent {
    private ICompteur modele;
    private IVue vue;
    
    public CompteurControle(ICompteur modele, IVue vue) {
        assert(modele != null && vue != null);
        this.modele = modele;
        this.vue = vue;
    }
    public void paintComponent(Graphics g) {
        this.vue.dessine(this.getEtat(), g, this);
    }
    public Dimension getPreferredSize() {
        return this.vue.getTaille(this.getEtat(), this);
    }
    public int getEtat() { 
        return this.modele.getEtat();
    }
    public void incrementer() {
        this.modele.incrementer();
        repaint(); // provoque l'appel de la mthode paintComponent
    }
    
    /**
     * Permet de changer la vue dynamiquement (au cours de la vie de l'objet)
     */
    void setVue(IVue newVue) {
        this.vue = newVue;
        repaint();
    }
}
