import javax.swing.*;
import java.awt.event.*;

/**
 * Exemple de MVC simple
 * 
 * @author F. Mallet 
 * @version 2004.08.24
 */
public class Exemple implements ActionListener
{
    private Compteur modele = new Compteur(0);
    private VueTexte vue = new VueTexte();
    private CompteurControle controleur = new CompteurControle(modele, vue);
    private JRadioButton tRB = new JRadioButton("Texte", true);
    private JRadioButton gRB = new JRadioButton("Graphique", false);
    private JFrame frame = new JFrame("Exemple MVC");
    
    private Exemple()
    {
        frame.getContentPane().add(controleur, "Center");
        JButton incB = new JButton("incrementer");
        frame.getContentPane().add(incB, "South");
        ButtonGroup bg = new ButtonGroup(); JPanel rbP = new JPanel();
        bg.add(tRB); rbP.add(tRB); tRB.addActionListener(this);
        bg.add(gRB); rbP.add(gRB); gRB.addActionListener(this);
        frame.getContentPane().add(rbP, "North");
        
        incB.addActionListener(this);
        frame.setBounds(100,100,200,150);
    }

    public void actionPerformed(ActionEvent ae) 
    {
        if (ae.getSource()==tRB)
            controleur.setVue(new VueTexte());
        else if (ae.getSource()==gRB)
            controleur.setVue(new VueGraph());
        else
            controleur.incrementer();
    }
    
    static public void demo() {
        Exemple ex = new Exemple();
        ex.frame.setVisible(true);
        ex.frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    }
}
